/*
;Funktion:                      Except3.cpp
;                               Demonstration eines Ausnahmefehlers mit komplexer
;                               Ausnahmefehler-Behandlung mit separater Behandlungs-
;                               routine im Anwenderprogramm

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -

;uebersetzen mit:               cl Except3.cpp      als 32bit-Programm

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Abschnitt E.4

;Copyright:                     (C) 2002-2021  Werner Zimmermann
;############################################################################
*/
#define _CRT_SECURE_NO_DEPRECATE	//Unterdrckt Sicherheitswarnung fr scanf() bei Visual Studio .NET 2005
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <stdio.h>
#include <conio.h>

int ergebnis, dividend=1, divisor;

//Routine zur Behandlung eines Ausnahmefehlers
DWORD exHandler(DWORD exCode)
{   
    if (exCode != EXCEPTION_INT_DIVIDE_BY_ZERO)     //Nur Divisionsfehler werden behandelt
        return EXCEPTION_CONTINUE_SEARCH;           //...bei anderen Fehlern wird eine uebergeordnete
                                                    //   Behandlungsroutine gesucht.

    printf("Fehler! Wollen Sie einen neuen Divisor eingeben: J/N ?    ");
    if (toupper(_getch()) == 'J')
    {   printf("\nDivisor  =    ");
        scanf("%d", &divisor);
        return EXCEPTION_CONTINUE_EXECUTION;        //Fehler korrigiert, nochmal dividieren
    } else
        return EXCEPTION_EXECUTE_HANDLER;           //Fehler wurde nicht korrigiert, __try-Block beenden
}


void main(void)
{   printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    printf("Divisionsprogramm: Geben Sie einen Dividenden und einen Divisor ein!\n\n");
    printf("Wenn Sie Divisor=0 eingeben, wird ein Ausnahmefehler ausgeloest und\n");
    printf("die Ausnahmefehler-Behandlung des Anwenderprogramms aufgerufen. Diese\n");
    printf("gibt eine Fehlermeldung aus und erlaubt Ihnen, den Divisor zu korrigieren.\n\n");
    printf("Sie koennen das Programm 'normal' beenden, indem Sie Dividend=0 eingeben\n\n");

    while (1)
    {   printf("\nDividend =    ");
        scanf("%d", &dividend);
        if (dividend == 0)
            break;
        printf("Divisor  =    ");
        scanf("%d", &divisor);

        __try
        {   ergebnis = dividend / divisor;      //<-- Befehl loest bei Divisor=0 Ausnahmefehler aus
            printf("Quotient =    %d / %d = %d\n", dividend, divisor, ergebnis);
        
        } __except( exHandler( GetExceptionCode() ) ) 
        {                                       //<-- Behandlung des Ausnahmefehlers, falls exHandler EXCEPTION_EXECUTE_HANDLER
            printf("\nUngueltiger Divisor - Fehler nicht korrigiert\n");        //   zurueck gibt
        };
     }
}
