/*
;Funktion:                      SimpleClient.cpp
;                               C++-Hauptprogramm

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -
;
;uebersetzen mit:               Microsoft Visual C++
;                               cl -Zi -MD SimpleClient.cpp Wsock32.lib
;

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Labor Systemprogrammierung, Abschnitt 4.2

;Copyright:                     (C) 2002-2021  Werner Zimmermann
*/

#define _CRT_SECURE_NO_DEPRECATE	//Unterdrckt Sicherheitswarnung fr strncpy() usw. bei Visual Studio .NET 2005
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>

typedef struct {SOCKET sock; SOCKADDR_IN addr; } SOCKDATA;

SOCKDATA sd;							//Socket-Datenstruktur

void OpenConnection(char *ServerIp, char *ServerPort)
{   char buffer[4096];                                          //Empfangspuffer
    int i;

    //***** Windows Socket Library laden *****
    WSAData wsaData;
    WSAStartup(0x0101, &wsaData);

    //***** Den Client-Socket initialisieren *****
    if ((sd.sock=socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)    //Socket erzeugen
    {   printf("Could not create socket - Winsock not loaded?");
        return;
    }
    setsockopt(sd.sock, SOL_SOCKET, SO_REUSEADDR, "1", sizeof(char));   //Socket als wiederverwendbar kennzeichnen

    //***** Verbindung mit Server herstellen *****
    sd.addr.sin_family= AF_INET;                           	//Adressfamilie Internet(TCP/IP)
    sd.addr.sin_port = htons(atoi(ServerPort));             	//Portadresse des Servers
    if ((sd.addr.sin_addr.S_un.S_addr = inet_addr(ServerIp)) == INADDR_NONE)        //IP-Adresse des Servers
    {   printf("Error in ServerIp !");
        return;
    }
    if ((connect(sd.sock, (SOCKADDR*) &sd.addr, sizeof(SOCKADDR)))==SOCKET_ERROR)
    {   printf("Could not connect - check ServerIp and port number !");
        return;
    }
    printf("Verbindung zum Server %s:%s hergestellt\n\n", ServerIp, ServerPort);

    //***** Schleife, solange der Client mit dem Server verbunden ist *****
    do
    {   gets_s(buffer, sizeof(buffer));                         //Zeichen von der Tastatur einlesen
        i=send(sd.sock, buffer, strlen(buffer), NULL);          //... und an Server senden
        if ((i==SOCKET_ERROR) || (i==0))                        //Abbruch bei Fehler oder wenn der Server die Verbindung beendet hat
            break;
        if (!strcmp(buffer,""))                                 //Abbruch, wenn eine leere Zeile eingegeben wird
            break;

        i=recv(sd.sock, buffer, sizeof(buffer), 0);             //Antwort des Servers einlesen
        if ((i==SOCKET_ERROR) || (i==0))                        //Abbruch bei Fehler oder wenn der Server die Verbindung beendet hat
            break;
        buffer[i]=0;                                            //Ende des Zeichenstrings mit 0h kennzeichnen
        printf("Empfangen: %s\n", buffer);                      //Antwort des Servers auf dem Bildschirm anzeigen
    } while (TRUE);

    printf("Verbindung zum Server wird geschlossen\n");
    closesocket(sd.sock);                                       //Socket des Client schliessen
}

void main(int argc, char* argv[])
{   char IpNummer[64]   = "127.0.0.1";                          //Default-Wert fuer die IP-Nummer (=lokaler PC)
    char PortNummer[64] = "1234";                               //Default-Wert fuer den IP-Port

    printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    if (argc <= 1)                                              //Verarbeitung der Kommandozeilen-Parameter
    {   printf("***** TCP/IP-Chatting Client *****\n");
        printf("Anwendung:   client Server_IP_Nummer Server_Port_Nummer\n");
        printf("             Server_IP_Nummer   optional, Defaultwert: 127.0.0.1 (=localhost)\n");
        printf("             Server_Port_Nummer optional, Defaultwert: 1234\n");
    } else if (argc <= 2)
    {    strncpy(IpNummer,argv[1], sizeof(IpNummer));           //IpNummer des Servers
    } else if (argc <= 3)
    {   strncpy(PortNummer,argv[2], sizeof(PortNummer));        //PortNummer des Servers
    }

    OpenConnection(IpNummer, PortNummer);                       //TCP/IP-Client starten
}
