/*
;Funktion:                      SimpleServer.cpp
;                               C++-Hauptprogramm

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -
;
;uebersetzen mit:               Microsoft Visual C++
;                               cl -Zi -MD SimpleServer.cpp Wsock32.lib
;

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Labor Systemprogrammierung, Abschnitt 4.2

;Copyright:                     (C) 2002-2021  Werner Zimmermann
*/

#define _CRT_SECURE_NO_DEPRECATE	//Unterdrckt Sicherheitswarnung fr strncpy() usw. bei Visual Studio .NET 2005
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>

typedef struct {SOCKET sock; SOCKADDR_IN addr; } SOCKDATA;

SOCKDATA sdSrv; 						//Socket-Daten fr den Server
SOCKDATA sdCli;							//Socket-Daten fr den Client whrend einer Verbindung

void StartServer(char *localPort)
{   char buffer[4096];                                          //Empfangspuffer
    int addrlen = sizeof(SOCKADDR_IN);                          //(enthaelt Daten des Clients)
    int i;

    //***** Windows Socket Library laden *****
    WSAData wsaData;
    WSAStartup(0x0101, &wsaData);

    //***** Den Server-Socket initialisieren *****
    if ((sdSrv.sock=socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)    //Socket erzeugen
    {   printf("Fehler beim Erzeugen des Server Socket - TCP/IP nicht installiert?");
        return;
    }
    setsockopt(sdSrv.sock, SOL_SOCKET, SO_REUSEADDR, "1", sizeof(char));   //Socket als wiederverwendbar kennzeichnen

    sdSrv.addr.sin_family= AF_INET;                            	//Adressfamilie Internet(TCP/IP)
    sdSrv.addr.sin_port = htons(atoi(localPort));              	//Portadresse des Servers
    sdSrv.addr.sin_addr.S_un.S_addr =  INADDR_ANY;             	//Verbindung mit beliebigem Client erlaubt
    if (bind(sdSrv.sock, (SOCKADDR *) &sdSrv.addr, sizeof(SOCKADDR_IN)))  	//Internetadresse und Portnummer zuordnen
    {   printf("Fehler bei bind()!");
        return;
    }
    if (listen(sdSrv.sock,5))                                      //Socket als Server-Socket definieren
    {   printf("Fehler bei listen()!");
        return;
    }

    printf("Server gestartet, wartet auf Client-Verbindung - Beenden mit STRG-C (CTRL-C)\n\n");

    //***** Warten, bis sich ein Client mit dem Server verbindet *****
    while ((sdCli.sock = accept(sdSrv.sock, (SOCKADDR *) &sdCli.addr, &addrlen)) != INVALID_SOCKET)
    {
        printf("*** Client %s:%d hat eine Verbindung hergestellt\n", inet_ntoa(sdCli.addr.sin_addr), htons(sdCli.addr.sin_port));

        //***** Schleife, solange ein Client mit dem Server verbunden ist *****
        do
        {   i=recv(sdCli.sock, buffer, sizeof(buffer), 0);     	//Warten, bis Zeichen vom Client empfangen werden
            if ((i==SOCKET_ERROR) || (i==0))                    //Abbruch bei Fehler oder wenn der Client die Verbindung beendet
                break;
            buffer[i]=0;                                        //Ende des Zeichenstrings mit 0h kennzeichnen
            printf("Empfangen: %s\n", buffer);                  //Empfangene Zeichen auf dem Bildschirm anzeigen

            _strupr(buffer);                                     //Empfangene Zeichen in Grossbuchstaben umwandeln
            i=send(sdCli.sock, buffer, strlen(buffer), NULL);  //... und an den Client zuruecksenden
            if (i==SOCKET_ERROR)                                //Abbruch bei Fehler, z.B. weil der Client die Verbindung beendet hat
                break;
        } while (TRUE);

        printf("*** Client %s:%d hat die Verbindung beendet\n", inet_ntoa(sdCli.addr.sin_addr), htons(sdCli.addr.sin_port));
    }
}

BOOL WINAPI closeServer(DWORD type)				//Callback-Funktion fuer CTRL-C
{   printf("*** Server wird beendet ***\n");
    closesocket(sdSrv.sock);					//Socket des Servers schliessen
    return TRUE;
}

void main(int argc, char* argv[])
{   char PortNummer[64]="1234";                                 //Default-Wert fuer den IP-Port

    printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    if (argc <= 1)
    {   printf("***** TCP/IP-Chatting Server *****\n");
        printf("Anwendung:   server PortNummer\n");
        printf("             PortNummer ist optional, Defaultwert: 1234\n");
    } else
    {   strncpy(PortNummer,argv[1], sizeof(PortNummer));
    }

    SetConsoleCtrlHandler(closeServer, TRUE);			//Callback-Funktion fuer CTRL-C installieren

    StartServer(PortNummer);                                    //TCP/IP-Server starten
}