/*
;Funktion:                      Thread2.cpp
;                               Thread Demonstration mit Thread-Prioritaeten

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -

;uebersetzen mit:               cl -Zi -MD Thread2.cpp  als 32bit-Programm

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Abschnitt E.3

;Hinweis:                       Multithread-Programme muessen mit cl -MT oder cl -MD
;                               uebersetzt werden, da die Default-C/C++-Bibliotheken
;                               nur fr Single-Thread-Programme geeignet sind. 
;                               Bei Verwendung des Developer Studios muss in folgendes
;                               eingestellt werden:
;                               Projekt - Einstellungen - Einstellungen fr: Alle 
;                               Konfigurationen - C/C++ - Kategorie: Code Generation -
;                               Laufzeit Bibliothek: Multithreaded oder Multithreaded DLL.

;Copyright:                     (C) 2004-2021  Werner Zimmermann

;############################################################################
*/

#define _WIN32_WINNT 0x0400                                             //Thread-Funktionen ab Windows NT 4.0 und neuer
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>

HANDLE hThreadA, hThreadB; 
int iA = 0, iB = 0;

void threadA(int& i)                                                    //Programmcode fr Thread A
{   
    printf("----- Thread A gestartet -----\n");
    SuspendThread(hThreadA);                                            //Thread A anhalten
    
    while(1)
    {   i++;                                                            //Zaehler A inkrementieren
    }
}

void threadB(int& i)                                                    //Programmcode fr Thread B               
{                                                                                                                  
    printf("----- Thread B gestartet -----\n");                                                                   
    ResumeThread(hThreadA);                                             //Thread A fortsetzen
    
    while(1)                                                            
    {   i++;                                                            //Zaehler B inkrementieren
    }                                                                   
}

void main(void)                                                         //Hauptprogramm
{   printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

//--Simulate a single CPU core even on multicore processors---
    DWORD_PTR myProcessAffinityMask, mySystemAffinityMask;
    GetProcessAffinityMask(GetCurrentProcess(), &myProcessAffinityMask, &mySystemAffinityMask);
    SetProcessAffinityMask(GetCurrentProcess(), 0x01);
//------------------------------------------------------------

    hThreadA = (HANDLE) _beginthread((void (*)(void *)) threadA,  0, (void *) &iA);     //Thread A erzeugen
    SetThreadPriority(hThreadA, THREAD_PRIORITY_HIGHEST);               //... und auf hohe Prioritaet setzen

    hThreadB = (HANDLE) _beginthread((void (*)(void *)) threadB,  0, (void *) &iB);     //Thread B erzeugen
    SetThreadPriority(hThreadB, THREAD_PRIORITY_LOWEST);                //... und auf niedrige Prioritaet setzen                
    
    printf("----- Hauptprogramm -----\n");
    SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);      //aktuellen Thread auf normale Prioritaet setzen (ueberfluessig, da Default)

    SwitchToThread();                                                   //Scheduler aufrufen um Thread A und B starten zu lassen
    
 
    while(!_kbhit())                                                     //Endlosschleife, solange keine Taste gedrueckt wird
    {   printf("Thread A: %8Xh   Thread B: %8Xh\n", iA, iB);            //Zaehlerstand ausgeben
        Sleep(1000);                                                    //1000ms Wartezeit
    }
}






