/*
;Funktion:                      Thread4.cpp
;                               Thread Demonstration mit Timer-Synchronisation

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -

;uebersetzen mit:               cl -Zi -MD Thread4.cpp  als 32bit-Programm

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Abschnitt E.3

;Hinweis:                       Multithread-Programme muessen mit cl -MT oder cl -MD
;                               uebersetzt werden, da die Default-C/C++-Bibliotheken
;                               nur fr Single-Thread-Programme geeignet sind. 
;                               Bei Verwendung des Developer Studios muss in folgendes
;                               eingestellt werden:
;                               Projekt - Einstellungen - Einstellungen fr: Alle 
;                               Konfigurationen - C/C++ - Kategorie: Code Generation -
;                               Laufzeit Bibliothek: Multithreaded oder Multithreaded DLL.

;Copyright:                     (C) 2002-2021  Werner Zimmermann

;############################################################################
*/

#define _WIN32_WINNT 0x0400                                             //Thread-Funktionen ab Windows NT 4.0 und neuer
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>

HANDLE hThreadA, hThreadB; 
HANDLE hTimerA,  hTimerB;
int iA = 0, iB = 0;

void threadA(int& i)                                                    //Programmcode fr Thread A
{   
    printf("----- Thread A gestartet -----\n");

    while(1)
    {   WaitForSingleObject(hTimerA, INFINITE);                         //Auf Timer A warten
        i++;                                                            //Zaehler A inkrementieren
    }
}

void threadB(int& i)                                                    //Programmcode fr Thread B               
{                                                                                                                  
    printf("----- Thread B gestartet -----\n");                                                                   

    while(1)                                                            
    {   WaitForSingleObject(hTimerB, INFINITE);                         //Auf Timer B warten
        i++;                                                            //Zaehler B inkrementieren
    }                                                                   
}

void main(void)                                                         //Hauptprogramm
{   LARGE_INTEGER dueTime = { 0, 0 };

    printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    hTimerA  = CreateWaitableTimer(NULL, FALSE, NULL);                  //Timer A erzeugen
    hTimerB  = CreateWaitableTimer(NULL, FALSE, NULL);                  //Timer B erzeugen
    
    hThreadA = (HANDLE) _beginthread((void (*)(void *)) threadA,  0, (void *) &iA);     //Thread A erzeugen
    hThreadB = (HANDLE) _beginthread((void (*)(void *)) threadB,  0, (void *) &iB);     //Thread B erzeugen
        
    printf("----- Hauptprogramm -----\n");
    SwitchToThread();                                                   //Scheduler aufrufen um Thread A und B starten zu lassen
   
    SetWaitableTimer(hTimerA, &dueTime, 400, NULL, NULL, FALSE);        //Timer A alle 200ms triggern
    SetWaitableTimer(hTimerB, &dueTime, 200, NULL, NULL, FALSE);        //Timer B alle 100ms triggern

    while(!_kbhit())                                                     //Endlosschleife, solange keine Taste gedrueckt wird
    {   printf("Thread A: %8u   Thread B: %8u\n", iA, iB);              //Zaehlerstand ausgeben
        Sleep(1001);                                                    //1000ms Wartezeit
    }
}






