/*
;Funktion:                      Thread5b.cpp
;                               Thread Demonstration mit gleichzeitigem Ressourcenzugriff
;                               mit Synchronisation durch Mutex

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -

;uebersetzen mit:               cl -Zi -MD Thread5b.cpp         als 32bit-Programm

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Abschnitt E.3

;Hinweis:                       Multithread-Programme muessen mit cl -MT oder cl -MD
;                               uebersetzt werden, da die Default-C/C++-Bibliotheken
;                               nur fr Single-Thread-Programme geeignet sind. 
;                               Bei Verwendung des Developer Studios muss in folgendes
;                               eingestellt werden:
;                               Projekt - Einstellungen - Einstellungen fr: Alle 
;                               Konfigurationen - C/C++ - Kategorie: Code Generation -
;                               Laufzeit Bibliothek: Multithreaded oder Multithreaded DLL.

;Copyright:                     (C) 2004-2021  Werner Zimmermann

;############################################################################
*/

#define _WIN32_WINNT 0x0400                                             //Thread-Funktionen ab Windows NT 4.0 und neuer
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>

HANDLE hThreadA, hThreadB; 

HANDLE hMutex;

void threadA(void)                                                      //Programmcode fr Thread A
{   int i;

    printf("----- Thread A gestartet -----\n");
    SuspendThread(hThreadA);                                            //Thread A anhalten
    
    while(1)
    {   WaitForSingleObject(hMutex, INFINITE);                          //Warten, bis Mutex frei ist
        for (i=0; i<13; i++)
            printf("%2u ", i);                                          //Ausgabe der Zahlen 1 ... 12
        printf("\n");
        ReleaseMutex(hMutex);                                           //Mutex freigeben
    }
}

void threadB(void)                                                      //Programmcode fr Thread B               
{   char c;                                                                                                               
    printf("----- Thread B gestartet -----\n");                                                                   
    ResumeThread(hThreadA);                                             //Thread A fortsetzen
    
    while(1)                                                            
    {   WaitForSingleObject(hMutex, INFINITE);                          //Warten, bis Mutex frei ist
        for (c='a'; c<'n'; c++)
            printf("%2c ", c);                                          //Ausgabe der Buchstaben a ... k
        printf("\n");
        ReleaseMutex(hMutex);                                           //Mutex freigeben
    }                                                                   
}

void main(void)                                                         //Hauptprogramm
{   printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    hMutex = CreateMutex(NULL, NULL, NULL);                             //Mutex erzeugen
        
    hThreadA = (HANDLE) _beginthread((void (*)(void *)) threadA,  0, NULL);     //Thread A erzeugen
    hThreadB = (HANDLE) _beginthread((void (*)(void *)) threadB,  0, NULL);     //Thread B erzeugen
        
    printf("----- Hauptprogramm -----\n");

    SwitchToThread();                                                   //Scheduler aufrufen um Thread A und B starten zu lassen
    
    while(!_kbhit())                                                     //Endlosschleife, solange keine Taste gedrueckt wird
    {   Sleep(1000);                                                    //1000ms Wartezeit
    }
}






