/*
;Funktion:                      Process3A.cpp
;                               Prozess Demonstration

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -

;uebersetzen mit:               cl -MD Process3A.cpp        als 32bit-Programm

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Abschnitt E
;                               Datenaustausch zwischen 2 Prozessen ber eine Pipe

;Copyright:                     (C) 2004-2021  Werner Zimmermann
;############################################################################
*/
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>


int i=0;                                                                //Zhlervariable 
int k;
HANDLE hProcessB, hPipe;                                                //Handle fr den Prozess B und die Pipe

#define _spawnl(param1,param2,param3) {STARTUPINFO startupInfo; PROCESS_INFORMATION processInfo; GetStartupInfo(&startupInfo);CreateProcess(param2,"",NULL,NULL,NULL,NULL,NULL,NULL,&startupInfo,&processInfo);*param3=processInfo.hProcess;}

void main(void)                                                 
{   printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    printf("A: --- Prozess A gestartet\n");
                                                                        //Pipe "myPipe" erzeugen
    hPipe=CreateNamedPipe("\\\\.\\pipe\\myPipe",PIPE_ACCESS_DUPLEX, 0, PIPE_UNLIMITED_INSTANCES, 0, 0, INFINITE, NULL);
    if (hPipe==INVALID_HANDLE_VALUE)
    {   printf("A: --- Could not create named pipe - exiting\n");
        return;
    }
    _spawnl(_P_NOWAIT, "process3B.exe", &hProcessB);       		//Prozess B erzeugen und starten
        
    ConnectNamedPipe(hPipe, NULL);                                      //Warten, bis der andere Prozess sich mit der Pipe verbindet
    printf("A: --- Prozess A und Prozess B durch die Pipe verbunden\n");
    
    while(!_kbhit())                                                     //Endlosschleife, solange keine Taste gedrueckt wird
    {   WriteFile(hPipe, &i, sizeof(i), (DWORD*) &k, NULL);             //--- Wert an die Pipe senden           
        ReadFile(hPipe,  &i, sizeof(i), (DWORD*) &k, NULL);             //--- Wert von der Pipe lesen
        printf("A: --- i=%u\n", i);                                     //--- Wert ausgeben
        Sleep(100);                                                     //--- Wartezeit bis zum nchsten Durchlauf
    }

    FlushFileBuffers(hPipe);                                            //Pipe-Puffer leeren
    DisconnectNamedPipe(hPipe);                                         //Pipe-Verbindung abbrechen
    CloseHandle(hPipe);                                                 //Pipe schliessen
    Sleep(100);                                                         //... und kurz warten
    
    TerminateProcess(hProcessB, 0);                                     //Prozess B beenden
    printf("A: --- Prozess A beendet\n");
}
