/*
;Funktion:                      Process3A.cpp
;                               Prozess Demonstration

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -

;uebersetzen mit:               cl -MD Process3A.cpp        als 32bit-Programm

;Aufgabenstellung:              siehe Vorlesung Rechnertechnik 2, Abschnitt E
;                               Datenaustausch zwischen 2 Prozessen ber Shared Memory

;Copyright:                     (C) 2004-2021  Werner Zimmermann

;############################################################################
*/
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>

HANDLE hProcessB, hSM;                                                  //Handle fr den Prozess B und den Shared Memory Bereich
int *pSMa;                                                              //Pointer auf den Shared Memory Bereich

#define _spawnl(param1,param2,param3) {STARTUPINFO startupInfo; PROCESS_INFORMATION processInfo; GetStartupInfo(&startupInfo);CreateProcess(param2,"",NULL,NULL,NULL,NULL,NULL,NULL,&startupInfo,&processInfo);*param3=processInfo.hProcess;}

void main(void)                                                 
{   printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    printf("A: --- Prozess A gestartet\n");
                                                                        //SharedMemory "mySharedMemory" erzeugen
    hSM=CreateFileMapping((HANDLE) -1, NULL, PAGE_READWRITE, 0, sizeof(int), "mySharedMemory");
    if (hSM==INVALID_HANDLE_VALUE)
    {   printf("A: --- Could not create named shared memory - exiting\n");
        return;
    }
    pSMa=(int*) MapViewOfFile(hSM, FILE_MAP_ALL_ACCESS, 0, 0, 0);       //... und in den Adressraum einblenden
    if (pSMa==NULL)
    {   printf("A: --- Could not map named shared memory - exiting\n");
        return;
    }
    
    _spawnl(_P_NOWAIT, "process4B.exe", &hProcessB);       		//Prozess B erzeugen und starten

    *pSMa=0;                                                            //Zhlerstand auf 0 setzen
    
    while(!_kbhit())                                                     //Endlosschleife, solange keine Taste gedrueckt wird
    {   printf("A: --- i=%u\n", *pSMa);                                 //--- Zhlerstand ausgeben
        Sleep(100);                                                     //--- Wartezeit bis zum nchsten Durchlauf
    }

    UnmapViewOfFile(pSMa);                                              //Shared Memory Adressbereich ausblenden
    CloseHandle(hSM);                                                   //... und schliessen
    
    TerminateProcess(hProcessB, 0);                                     //Prozess B beenden
    printf("A: --- Prozess A beendet\n");
}
