/*
;Funktion:                      Process3B.cpp
;                               Prozess Demonstration

;getestet unter:                Konsole Windows NT/2000/XP/7/10
;funktioniert nicht unter:      -

;uebersetzen mit:               cl -MD Process3B.cpp        als 32bit-Programm

;Aufgabenstellung:              wird von Process3A gestartet

;Copyright:                     (C) 2004-2021  Werner Zimmermann
;############################################################################
*/
#ifdef  _WIN64	
    #define isVer "WIN64"	
#else
#ifdef  _WIN32
    #define isVer "WIN32"	
#endif
#endif

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>

HANDLE hSM;                                                             //Handle fr den Shared Memory Bereich
int *pSMb;                                                              //Pointer auf den Shared Memory Bereich

void main(void)
{   printf("(C) 2002-2021 -- Zimmermann, HS Esslingen -- %s --\n\n", isVer); 

    printf("B: *** Prozess B gestartet\n");

    hSM=OpenFileMapping(FILE_MAP_ALL_ACCESS, TRUE, "mySharedMemory");   //Shared memory ffnen
    if (hSM==INVALID_HANDLE_VALUE)
    {   printf("A: --- Could not create named shared memory - exiting\n");
        return;
    }
    pSMb=(int*) MapViewOfFile(hSM, FILE_MAP_ALL_ACCESS, 0, 0, 0);       //... und in den Adressraum einblenden
    if (pSMb==NULL)
    {   printf("A: --- Could not map named shared memory - exiting\n");
        return;
    }
    
    while(1)                                                            //Endlosschleife (ohne Abbruchbedingung)
    {   (*pSMb)++;                                                      //---Zhlerstand inkrementieren
    }

    //Die folgenden Befehle werden nie ausgefhrt, da die Endlosschleife keine Abbruchbedingung hat
    UnmapViewOfFile(pSMb);                                              //Shared Memory Adressbereich ausblenden
    CloseHandle(hSM);                                                   //... und schliessen

    printf("B: *** Prozess B beendet\n");                               
}
